<?php
namespace App\Factory;

use App\Exception;

class IntegrationFactory {
    private $connection;

    public function __construct (\Doctrine\DBAL\Connection $connection) {
        $this->connection = $connection;
    }
    
    public function disableIntegration() {
        $sql = "
            UPDATE INTEGRACAO
               SET IDHABINTE    = 'N'
             WHERE IDINTEGRACAO = 'PED'
        ";
        
        $this->connection->executeQuery($sql);
    }

    public function getConfiguration() {
        $sql = "
            SELECT IDUFTIMEZONE, IDTOKENINTGERAL, IDSENHATOKENGERAL, IDHABINTE, IDRASTREIAENTREGA, IDUTLVNDPDRPALC
              FROM INTEGRACAO
             WHERE IDINTEGRACAO = 'PED'
        ";
        
        return $this->connection->fetchAssoc($sql);
    }

    public function getMerchantConfiguration($cdFilial) {
        $idIntegracao = "PED";

        $sql = "
            SELECT CDFILIAL, IDTOKEN, IDUTLENTRETERC, IDRETTXENTR, CDLOJA, CDCAIXA
              FROM INTEGRACAOFILI 
             WHERE CDINTEGRACAO = (SELECT CDINTEGRACAO FROM INTEGRACAO WHERE IDINTEGRACAO = :IDINTEGRACAO)
               AND CDFILIAL     = :CDFILIAL
               AND ROWNUM       = 1
        ";
        
        $params = [
            ":IDINTEGRACAO" => $idIntegracao,
            ":CDFILIAL"     => $cdFilial
        ];
        
        return $this->connection->fetchAll($sql, $params)[0];
    }

}
